"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var automerge_1 = __importDefault(require("automerge"));
var updateAutomergeDoc_1 = __importDefault(require("./updateAutomergeDoc"));
function makeCodeMirrorChangeHandler(watchableDoc, getText, mutex) {
    var text = getText(watchableDoc.get());
    if (!text) {
        throw new Error("Cannot connect CodeMirror. Did not find text in " + JSON.stringify(watchableDoc.get()));
    }
    var textObjectId = automerge_1.default.getObjectId(text);
    var codeMirrorChangeHandler = function (editor, change) {
        if (change.origin !== 'automerge') {
            mutex.lock();
            var newDoc = updateAutomergeDoc_1.default(watchableDoc.get(), getText, editor.getDoc(), change);
            watchableDoc.set(newDoc);
            mutex.release();
        }
    };
    return { textObjectId: textObjectId, codeMirrorChangeHandler: codeMirrorChangeHandler };
}
exports.default = makeCodeMirrorChangeHandler;
//# sourceMappingURL=makeCodeMirrorChangeHandler.js.map