"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var automerge_1 = __importDefault(require("automerge"));
var react_1 = __importDefault(require("react"));
var AutomergeCodeMirror_1 = __importDefault(require("../../src/react/AutomergeCodeMirror"));
var codemirror_1 = __importDefault(require("codemirror"));
var useAutomergeDoc_1 = __importDefault(require("../../src/react/useAutomergeDoc"));
var PadComponent = function (_a) {
    var watchableDoc = _a.watchableDoc, connectCodeMirror = _a.connectCodeMirror;
    var doc = useAutomergeDoc_1.default(watchableDoc);
    function createSheet() {
        watchableDoc.set(automerge_1.default.change(watchableDoc.get(), function (draft) {
            if (draft.sheets == undefined)
                draft.sheets = [];
            draft.sheets.push(new automerge_1.default.Text());
        }));
    }
    function removeSheet() {
        watchableDoc.set(automerge_1.default.change(watchableDoc.get(), function (draft) {
            if (draft.sheets) {
                draft.sheets.shift();
            }
        }));
    }
    function makeCodeMirror(element) {
        return codemirror_1.default(element, {
            viewportMargin: Infinity,
            lineWrapping: true,
            extraKeys: {
                Tab: false,
            },
        });
    }
    return (react_1.default.createElement("div", { className: "pad" },
        react_1.default.createElement("button", { onClick: createSheet }, "New Sheet"),
        react_1.default.createElement("button", { onClick: removeSheet }, "Remove Sheet"),
        (doc.sheets || []).map(function (_, i) {
            function getText(doc) {
                return doc.sheets[i];
            }
            return (react_1.default.createElement("div", { key: i, className: "sheet" },
                react_1.default.createElement(AutomergeCodeMirror_1.default, { makeCodeMirror: makeCodeMirror, connectCodeMirror: connectCodeMirror, getText: getText })));
        })));
};
exports.PadComponent = PadComponent;
//# sourceMappingURL=PadComponent.js.map