"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("@storybook/react");
var react_2 = __importDefault(require("react"));
require("codemirror/lib/codemirror.css");
require("codemirror/theme/material.css");
var automerge_1 = __importDefault(require("automerge"));
require("./style.css");
var PadComponent_1 = require("./components/PadComponent");
var connectAutomergeDoc_1 = __importDefault(require("../src/connectAutomergeDoc"));
react_1.storiesOf('Collaboration', module).add('Multiple CodeMirrors linked to a single Automerge doc', function () {
    var watchableDocWilma = new automerge_1.default.WatchableDoc(automerge_1.default.init());
    var watchableDocFred = new automerge_1.default.WatchableDoc(automerge_1.default.init());
    var watchableDocBarney = new automerge_1.default.WatchableDoc(automerge_1.default.init());
    connect(watchableDocWilma, watchableDocFred);
    connect(watchableDocFred, watchableDocBarney);
    return (react_2.default.createElement("div", null,
        react_2.default.createElement("p", null, "Below are three actors - Wilma, Fred and Barney. They each have a Pad with sheets. Each sheet is connected to a CodeMirror editor."),
        react_2.default.createElement("p", null, "Wilma and Fred's pads are connected. Fred and Barney's pads are also connected. When either of them creates a new pad or edits a sheet in a pad, changes are reflected in the other's pads and sheets."),
        react_2.default.createElement("p", null,
            "The source code is",
            ' ',
            react_2.default.createElement("a", { href: "https://github.com/aslakhellesoy/automerge-codemirror/blob/master/stories/index.stories.tsx" }, "here"),
            "."),
        react_2.default.createElement("div", { className: "pads" },
            react_2.default.createElement("div", null,
                react_2.default.createElement("h3", null, "Wilma"),
                react_2.default.createElement(PadComponent_1.PadComponent, { watchableDoc: watchableDocWilma, connectCodeMirror: connectAutomergeDoc_1.default(watchableDocWilma) })),
            react_2.default.createElement("div", null,
                react_2.default.createElement("h3", null, "Fred"),
                react_2.default.createElement(PadComponent_1.PadComponent, { watchableDoc: watchableDocFred, connectCodeMirror: connectAutomergeDoc_1.default(watchableDocFred) })),
            react_2.default.createElement("div", null,
                react_2.default.createElement("h3", null, "Barney"),
                react_2.default.createElement(PadComponent_1.PadComponent, { watchableDoc: watchableDocBarney, connectCodeMirror: connectAutomergeDoc_1.default(watchableDocBarney) })))));
});
function connect(watchableDocA, watchableDocB) {
    watchableDocA.registerHandler(function () {
        return setIfDifferent(watchableDocB, automerge_1.default.merge(watchableDocB.get(), watchableDocA.get()));
    });
    watchableDocB.registerHandler(function () {
        return setIfDifferent(watchableDocA, automerge_1.default.merge(watchableDocA.get(), watchableDocB.get()));
    });
}
function setIfDifferent(watchableDoc, doc) {
    if (watchableDoc.get() !== doc) {
        watchableDoc.set(doc);
    }
}
//# sourceMappingURL=index.stories.js.map