"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
require("../codeMirrorEnv");
var react_dom_1 = require("react-dom");
var codemirror_1 = __importDefault(require("codemirror"));
var automerge_1 = __importDefault(require("automerge"));
var AutomergeCodeMirror_1 = __importDefault(require("../../src/react/AutomergeCodeMirror"));
var react_1 = __importDefault(require("react"));
var assert_1 = __importDefault(require("assert"));
var connectAutomergeDoc_1 = __importDefault(require("../../src/connectAutomergeDoc"));
describe('<AutomergeCodeMirror>', function () {
    var watchableDoc;
    var getText = function (doc) { return doc.text; };
    var host;
    beforeEach(function () {
        watchableDoc = new automerge_1.default.WatchableDoc(automerge_1.default.from({ text: new automerge_1.default.Text() }));
        host = document.body.appendChild(document.createElement('div'));
    });
    afterEach(function () {
        react_dom_1.unmountComponentAtNode(host);
        host.remove();
    });
    it('updates Automerge doc when CodeMirror doc changes', function () { return __awaiter(void 0, void 0, void 0, function () {
        var connectCodeMirror, codeMirror;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    connectCodeMirror = connectAutomergeDoc_1.default(watchableDoc);
                    return [4 /*yield*/, makeCodeMirror(connectCodeMirror, watchableDoc, getText, host)];
                case 1:
                    codeMirror = _a.sent();
                    codeMirror.setValue('hello');
                    assert_1.default.strictEqual(watchableDoc.get().text.toString(), 'hello');
                    return [2 /*return*/];
            }
        });
    }); });
    it('updates CodeMirror doc when Automerge doc changes', function () { return __awaiter(void 0, void 0, void 0, function () {
        var connectCodeMirror, codeMirror;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    connectCodeMirror = connectAutomergeDoc_1.default(watchableDoc);
                    return [4 /*yield*/, makeCodeMirror(connectCodeMirror, watchableDoc, getText, host)];
                case 1:
                    codeMirror = _a.sent();
                    watchableDoc.set(automerge_1.default.change(watchableDoc.get(), function (draft) { return draft.text.insertAt(0, 'hello'); }));
                    assert_1.default.strictEqual(codeMirror.getValue(), 'hello');
                    return [2 /*return*/];
            }
        });
    }); });
});
function makeCodeMirror(connectCodeMirror, watchableDoc, getText, host) {
    return new Promise(function (resolve) {
        function makeCodeMirror(host) {
            var cm = codemirror_1.default(host);
            resolve(cm);
            return cm;
        }
        react_dom_1.render(react_1.default.createElement(AutomergeCodeMirror_1.default, { makeCodeMirror: makeCodeMirror, connectCodeMirror: connectCodeMirror, getText: getText }), host);
    });
}
//# sourceMappingURL=AutomergeCodeMirrorTest.js.map